require "import"
import "android.widget.*"
import "android.view.*"
import "android.content.Intent"
import "android.net.Uri"

layout = {
  LinearLayout,
  orientation = "vertical",
  layout_width = "fill",
  layout_height = "fill",
  padding = "16dp",
  {
    TextView,
    text = "Select Language:",
    textSize = "18sp",
    layout_marginBottom = "8dp"
  },
  {
    Spinner,
    id = "languageSpinner",
    layout_width = "match_parent",
    layout_height = "wrap_content"
  },
  {
    LinearLayout,
    orientation = "horizontal",
    layout_width = "match_parent",
    layout_height = "wrap_content",
    layout_marginTop = "16dp",
    gravity = "center",
    {
      Button,
      id = "listenButton",
      text = "Listen Story",
      layout_weight = 1
    },
    {
      Button,
      id = "aboutButton",
      text = "About Us",
      layout_weight = 1
    }
  },
  {
    LinearLayout,
    id = "optionLayout",
    orientation = "vertical",
    layout_width = "match_parent",
    layout_height = "wrap_content",
    layout_marginTop = "16dp"
  }
}

activity.setContentView(loadlayout(layout))

languages = {"Marathi", "Hindi"}
languageSpinner.setAdapter(ArrayAdapter(this, android.R.layout.simple_spinner_dropdown_item, String(languages)))

function openLink(url)
  intent = Intent(Intent.ACTION_VIEW, Uri.parse(url))
  activity.startActivity(intent)
end

function showStoryOptions(language)
  optionLayout.removeAllViews()
  if language == "Marathi" then
    local stories = {
      {"GB Story Trailer", "https://youtube.com/@gbstoryteller?si=aunll8_LTQ821SlD"},
      {"Tu Apni Duniyadari", "https://youtube.com/@user-aapliduniyadari-9ghosts?si=sj4r2iesKJbTmQm7"},
      {"All Entertainment", "https://youtube.com/channel/UCWsWK5qkLlc2C9ItDapvVIg?si=XjXIg3N-nraPhA9J"}
    }
    for _, s in ipairs(stories) do
      local btn = Button(this)
      btn.setText(s[1])
      btn.setOnClickListener(function() openLink(s[2]) end)
      optionLayout.addView(btn)
    end
  elseif language == "Hindi" then
    local stories = {
      {"Khooni Monday", "https://youtube.com/@khoonimonday?si=s5-jQ6cfvgf-KpwY"},
      {"Scary Pumpkin", "https://youtube.com/@scarypumpkin?si=7mqtkhL_BvYlNu8I"}
    }
    for _, s in ipairs(stories) do
      local btn = Button(this)
      btn.setText(s[1])
      btn.setOnClickListener(function() openLink(s[2]) end)
      optionLayout.addView(btn)
    end
  end
end

function showAboutUs()
  optionLayout.removeAllViews()
  local text = TextView(this)
  text.setText("Hi guys, welcome to this tool developed by: Blind Take Kunal")
  optionLayout.addView(text)

  local subscribeBtn = Button(this)
  subscribeBtn.setText("Subscribe our Channel")
  subscribeBtn.setOnClickListener(function()
    openLink("https://youtube.com/@kunalnimbalkar-qg6xu?si=tB4twB-obze9k0In")
  end)
  optionLayout.addView(subscribeBtn)

  local whatsappBtn = Button(this)
  whatsappBtn.setText("Join our WhatsApp Group")
  whatsappBtn.setOnClickListener(function()
    openLink("https://chat.whatsapp.com/C7zqJHQlI4T5XwPQbfVfqX")
  end)
  optionLayout.addView(whatsappBtn)
end

listenButton.setOnClickListener(function()
  local selected = languageSpinner.getSelectedItem()
  showStoryOptions(selected)
end)

aboutButton.setOnClickListener(function()
  showAboutUs()
end)